<?php // $Id: teacherview.php,v 1.10 2009/07/29 19:05:40 diml Exp $

/**
* @package mod-scheduler
* @category mod
* @author Gustav Delius, Valery Fremaux > 1.8
*
* This page prints the screen view for the teachers. It realizes all "view" related use cases.
*
* @usecase addslot
* @usecase updateslot
* @usecase addsession
* @usecase delsession
* @usecase schedule
* @usecase schedulegroup
* @usecase viewstatistics
* @usecase viewstudent
* @usecase downloads
*/

/**
*
*/
function get_slot_data(&$form){
    if (!$form->hideuntil   = optional_param('hideuntil', '', PARAM_INT)){
        $form->displayyear  = required_param('displayyear', PARAM_INT);
        $form->displaymonth = required_param('displaymonth', PARAM_INT);
        $form->displayday   = required_param('displayday', PARAM_INT);
        $form->hideuntil    = make_timestamp($form->displayyear, $form->displaymonth, $form->displayday);
    }
    if (!$form->starttime   = optional_param('starttime', '', PARAM_INT)){
        $form->year         = required_param('year', PARAM_INT);
        $form->month        = required_param('month', PARAM_INT);
        $form->day          = required_param('day', PARAM_INT);
        $form->hour         = required_param('hour', PARAM_INT);
        $form->minute       = required_param('minute', PARAM_INT);
        $form->starttime    = make_timestamp($form->year, $form->month, $form->day, $form->hour, $form->minute);
    }
    $forcegroupappoint = optional_param('forcegroupappoint', 0, PARAM_INT);
    if($forcegroupappoint) {
        $form->exclusivity = 0;
    } else {
        $form->exclusivity = required_param('exclusivity', PARAM_INT);
    }
    $form->reuse     = required_param('reuse', PARAM_INT);
    $form->duration  = required_param('duration', PARAM_INT);
    $form->notes     = required_param('notes', PARAM_TEXT);
    $form->teacherid = required_param('teacherid', PARAM_INT);
    $form->appointmentlocation = required_param('appointmentlocation', PARAM_CLEAN);
}

/**
*
*/
function get_session_data(&$form){
    if (!$form->rangestart = optional_param('rangestart', '', PARAM_INT)){
        $year   = required_param('startyear', PARAM_INT);
        $month  = required_param('startmonth', PARAM_INT);
        $day    = required_param('startday', PARAM_INT);
        $form->rangestart   = make_timestamp($year, $month, $day);
        $form->starthour    = required_param('starthour', PARAM_INT);
        $form->startminute  = required_param('startminute', PARAM_INT);
        $form->timestart    = make_timestamp($year, $month, $day, $form->starthour, $form->startminute);
    }
    if (!$form->rangeend = optional_param('rangeend', '', PARAM_INT)){
        $year   = required_param('endyear', PARAM_INT);
        $month  = required_param('endmonth', PARAM_INT);
        $day    = required_param('endday', PARAM_INT);
        $form->rangeend  = make_timestamp($year, $month, $day);
        $form->endhour   = required_param('endhour', PARAM_INT);
        $form->endminute = required_param('endminute', PARAM_INT);
        $form->timeend   = make_timestamp($year, $month, $day, $form->endhour, $form->endminute);
    }
    $form->monday       = optional_param('monday', 0, PARAM_INT);
    $form->tuesday      = optional_param('tuesday', 0, PARAM_INT);
    $form->wednesday    = optional_param('wednesday', 0, PARAM_INT);
    $form->thursday     = optional_param('thursday', 0, PARAM_INT);
    $form->friday       = optional_param('friday', 0, PARAM_INT);
    $form->saturday     = optional_param('saturday', 0, PARAM_INT);
    $form->sunday       = optional_param('sunday', 0, PARAM_INT);
    $form->forcewhenoverlap = required_param('forcewhenoverlap', PARAM_INT);
    $forcegroupappoint  = optional_param('forcegroupappoint', 0, PARAM_INT);
    if($forcegroupappoint) {
        $form->exclusivity = 0;
    } else {
        $form->exclusivity = required_param('exclusivity', PARAM_INT);
    }
    $form->reuse        = required_param('reuse', PARAM_INT);
    $form->divide       = optional_param('divide', 0, PARAM_INT);
    $form->duration     = optional_param('duration', 15, PARAM_INT);
    $form->teacherid    = required_param('teacherid', PARAM_INT);
    $form->appointmentlocation = optional_param('appointmentlocation', '', PARAM_CLEAN);
    $form->emailfrom    = required_param('emailfrom', PARAM_CLEAN);
    $form->displayfrom  = required_param('displayfrom', PARAM_CLEAN);
}

/**
*
*/
function get_delete_data(&$form){
    if (!$form->rangestart  = optional_param('rangestart', '', PARAM_INT)){
        $year               = required_param('startyear', PARAM_INT);
        $month              = required_param('startmonth', PARAM_INT);
        $day                = required_param('startday', PARAM_INT);
        $form->rangestart   = make_timestamp($year, $month, $day);
        $form->starthour    = required_param('starthour', PARAM_INT);
        $form->startminute  = required_param('startminute', PARAM_INT);
        $form->timestart    = make_timestamp($year, $month, $day, $form->starthour, $form->startminute);
    }
    if (!$form->rangeend = optional_param('rangeend', '', PARAM_INT)){
        $year            = required_param('endyear', PARAM_INT);
        $month           = required_param('endmonth', PARAM_INT);
        $day             = required_param('endday', PARAM_INT);
        $form->rangeend  = make_timestamp($year, $month, $day);
        $form->endhour   = required_param('endhour', PARAM_INT);
        $form->endminute = required_param('endminute', PARAM_INT);
        $form->timeend   = make_timestamp($year, $month, $day, $form->endhour, $form->endminute);
    }
    $form->monday       = optional_param('monday', 0, PARAM_INT);
    $form->tuesday      = optional_param('tuesday', 0, PARAM_INT);
    $form->wednesday    = optional_param('wednesday', 0, PARAM_INT);
    $form->thursday     = optional_param('thursday', 0, PARAM_INT);
    $form->friday       = optional_param('friday', 0, PARAM_INT);
    $form->saturday     = optional_param('saturday', 0, PARAM_INT);
    $form->sunday       = optional_param('sunday', 0, PARAM_INT);

    $form->teacherid = optional_param('teacherid', '0', PARAM_INT);
    $form->appointmentlocation = optional_param('appointmentlocation', '', PARAM_CLEAN);
}

    /**
    *
    */
    if (!defined('MOODLE_INTERNAL')){
        die('Direct access to this script is forbidden!');
    }

    if ($action){
        include($CFG->dirroot.'/mod/scheduler/teacherview.controller.php');
    }

/************************************ View : New single slot form ****************************************/
if ($action == 'addslot'){
    print_heading(get_string('addsingleslot', 'scheduler'));

    if (empty($subaction)){
        $form->what = 'doaddupdateslot';
        // blank appointment data
        if (empty($form->appointments)) $form->appointments = array();
        $form->starttime = time();
        $form->duration = 15;
        $form->reuse = 1;
        $form->exclusivity = 1;
        $form->hideuntil = $scheduler->timemodified; // supposed being in the past so slot is visible
        $form->notes = '';
        $form->teacherid = $USER->id;
        $form->appointmentlocation = scheduler_get_last_location($scheduler);
    } elseif($subaction == 'cancel') {
        get_slot_data($form);
        $form->what = 'doaddupdateslot';
        $form->appointments = unserialize(stripslashes(required_param('appointmentssaved', PARAM_RAW)));
    } else {
        $retcode = include "teacherview.subcontroller.php";
        if ($retcode == -1) return -1;
    }

    /// print errors
    if (!empty($errors)){
        $errorstr = '';
        foreach($errors as $anError){
            $errorstr .= $anError->message;
        }
        print_simple_box($errorstr, 'center', '70%', '', 5, 'errorbox');
    }

    /// print form
    print_simple_box_start('center', '', '');
    include('oneslotform.html');
    print_simple_box_end();
    echo '<br />';

    // return code for include
    return -1;
}
/************************************ View : Update single slot form ****************************************/
if ($action == 'updateslot') {
    $slotid = required_param('slotid', PARAM_INT);

    print_general_tabs($cm, $scheduler );
    print_heading(get_string('updatesingleslot', 'scheduler'));

    if(empty($subaction)){
        if(!empty($errors)){ // if some errors, get data from client side
            get_slot_data($form);
            $form->appointments = unserialize(stripslashes(required_param('appointments', PARAM_RAW)));
        } else {
            /// get data from the last inserted
            $slot = $DB->get_record('scheduler_slots', array('id' => $slotid));
            $form = &$slot;
            // get all appointments for this slot
            $form->appointments = array();
            $appointments = $DB->get_records('scheduler_appointment', array('slotid' => $slotid));
            // convert appointement keys to studentid
            if ($appointments){
                foreach($appointments as $appointment){
                    $form->appointments[$appointment->studentid] = $appointment;
                }
            }
        }
    } elseif($subaction == 'cancel') {
        get_slot_data($form);
        $form->appointments = unserialize(stripslashes(required_param('appointmentssaved', PARAM_RAW)));
        $form->studentid = required_param('studentid', PARAM_INT);
        $form->slotid = required_param('slotid', PARAM_INT);
        $form->what = 'doaddupdateslot';
    } elseif($subaction != '') {
        $retcode = include $CFG->dirroot.'/mod/scheduler/teacherview.subcontroller.php';
        if ($retcode == -1) return -1;
    }

    // print errors and notices
    if (!empty($errors)){
        $errorstr = '';
        foreach($errors as $anError){
            $errorstr .= $anError->message;
        }
        print_simple_box($errorstr, 'center', '70%', '', 5, 'errorbox');
    }

    /// print form
    $form->what = 'doaddupdateslot';

    print_simple_box_start('center', '', '');
    include($CFG->dirroot.'/mod/scheduler/oneslotform.html');
    print_simple_box_end();
    echo '<br />';

    // return code for include
    return -1;
}
/************************************ Add session multiple slots form ****************************************/
if ($action == 'addsession') {
    // if there is some error from controller, display it
    if (!empty($errors)){
        $errorstr = '';
        foreach($errors as $anError){
            $errorstr .= $anError->message;
        }
        print_simple_box($errorstr, 'center', '70%', '', 5, 'errorbox');
    }

    if (!empty($errors)){
        get_session_data($data);
        $form = &$data;
    } else {
        $form->rangestart = time();
        $form->rangeend = time();
        $form->timestart = time();
        $form->timeend = time() + HOURSECS;
        $form->hideuntil = $scheduler->timemodified;
        $form->duration = $scheduler->defaultslotduration;
        $form->forcewhenoverlap = 0;
        $form->teacherid = $USER->id;
        $form->exclusivity = 1;
        $form->duration = $scheduler->defaultslotduration;
        $form->reuse = 1;
        $form->monday = 1;
        $form->tuesday = 1;
        $form->wednesday = 1;
        $form->thursday = 1;
        $form->friday = 1;
        $form->saturday = 0;
        $form->sunday = 0;
    }

    print_heading(get_string('addsession', 'scheduler'));
    print_simple_box_start('center', '', '');
    include_once($CFG->dirroot.'/mod/scheduler/addslotsform.html');
    print_simple_box_end();
    echo '<br />';

    // return code for include
    return -1;
}
/************************************ Add session multiple slots form ****************************************/
if ($action == 'delsession') {
    // if there is some error from controller, display it
    if (!empty($errors)){
        $errorstr = '';
        foreach($errors as $anError){
            $errorstr .= $anError->message;
        }
        print_simple_box($errorstr, 'center', '70%', '', 5, 'errorbox');
    }

    if (!empty($errors)){
        get_session_data($data);
        $form = &$data;
    } else {
        $form->rangestart = time();
        $form->rangeend = time();
        $form->timestart = time();
        $form->timeend = time() + HOURSECS;
        $form->teacherid = $USER->id;
        $form->monday = 1;
        $form->tuesday = 1;
        $form->wednesday = 1;
        $form->thursday = 1;
        $form->friday = 1;
        $form->saturday = 0;
        $form->sunday = 0;
    }

    print_heading(get_string('delsession', 'scheduler'));
    print_simple_box_start('center', '', '');
    include_once($CFG->dirroot.'/mod/scheduler/deleteslotsform.html');
    print_simple_box_end();
    echo '<br />';

    // return code for include
    return -1;
}

/************************************ Schedule a student form ***********************************************/
if ($action == 'schedule') {
    if ($subaction == 'dochooseslot'){
        /// set an advice message
        unset($erroritem);
        $erroritem->message = get_string('dontforgetsaveadvice', 'scheduler');
        $erroritem->on = '';
        $errors[] = $erroritem;

        $slotid = required_param('slotid', PARAM_INT);
        $studentid = required_param('studentid', PARAM_INT);
        if ($slot = $DB->get_record('scheduler_slots', array('id' => $slotid))){
            $form = &$slot;

            $form->studentid = $studentid;
            $form->what = 'doaddupdateslot';
            $form->slotid = $slotid;
            $form->availableslots = scheduler_get_available_slots($studentid, $scheduler->id);
            $appointment->studentid = $studentid;
            $appointment->attended = optional_param('attended', 0, PARAM_INT);
            $appointment->grade = optional_param('grade', 0, PARAM_INT);
            $appointment->appointmentnote = optional_param('appointmentnote', '', PARAM_TEXT);
            $appointment->timecreated = time();
            $appointment->timemodified = time();
            $appointments = get_records('scheduler_appointment', 'slotid', $slotid);
            $appointments[$appointment->studentid] = $appointment;
            $form->appointments = $appointments;
        } else {
            $form->studentid = $studentid;
            $form->what = 'doaddupdateslot';
            $form->slotid = 0;
            $form->starttime = time();
            $form->duration = 15;
            $form->reuse = 1;
            $form->exclusivity = 1;
            $form->hideuntil = $scheduler->timemodified; // supposed being in the past so slot is visible
            $form->notes = '';
            $form->teacherid = $USER->id;
            $form->appointmentlocation = scheduler_get_last_location($scheduler);
            $form->availableslots = scheduler_get_available_slots($studentid, $scheduler->id);
            $form->appointments = unserialize(stripslashes(required_param('appointments', PARAM_RAW)));
        }
    } elseif($subaction == 'cancel') {
        get_slot_data($form);
        $form->appointments = unserialize(stripslashes(required_param('appointments', PARAM_RAW)));
        $form->studentid = required_param('studentid', PARAM_INT);
        $form->slotid = required_param('slotid', PARAM_INT);
        $form->availableslots = scheduler_get_available_slots($form->studentid, $scheduler->id);
        $form->what = 'doaddupdateslot';
    } elseif(empty($subaction)) {
        if (!empty($errors)){
            get_slot_data($form);
            $form->availableslots = scheduler_get_available_slots($form->studentid, $scheduler->id);
            $form->studentid = required_param('studentid', PARAM_INT);
            $form->seen = optional_param('seen', 0, PARAM_INT);
            $form->slotid = optional_param('slotid', -1, PARAM_INT);
        } else {
            $form->studentid = required_param('studentid', PARAM_INT);
            $form->seen = optional_param('seen', 0, PARAM_INT);

            /// getting available slots
            $form->availableslots = scheduler_get_available_slots($form->studentid, $scheduler->id);
            $form->what = 'doaddupdateslot' ;
            $form->starttime = time();
            $form->duration = $scheduler->defaultslotduration;
            $form->reuse = 1;
            $form->exclusivity = 1;
            $form->hideuntil = $scheduler->timemodified; // supposed being in the past so slot is visible
            $form->notes = '';
            $form->teacherid = $USER->id;
            $form->appointmentlocation = scheduler_get_last_location($scheduler);
            $form->slotid = 0;
            $appointment->slotid = -1;
            $appointment->studentid = $form->studentid;
            $appointment->appointmentnote = '';
            $appointment->attended = $form->seen;
            $appointment->grade = '';
            $appointment->timecreated = time();
            $appointment->timemodified = time();
            $form->appointments[$form->studentid] = $appointment;
        }
    } elseif($subaction != '') {
        $retcode = include($CFG->dirroot.'/mod/scheduler/teacherview.subcontroller.php');
        if ($retcode == -1) return -1;
    }

    // display error or advices
    if (!empty($errors)){
        $errorstr = '';
        foreach($errors as $anError){
            $errorstr .= $anError->message;
        }
        print_simple_box($errorstr, 'center', '70%', '', 5, 'errorbox');
    }

    // diplay form
    $form->student = $DB->get_record('user', array('id' => $form->studentid));
    $studentname = fullname($form->student, true);
    print_general_tabs($cm, $scheduler, 'unscheduled');
    print_heading(get_string('scheduleappointment', 'scheduler', $studentname));
    print_simple_box_start('center', '', '');
    include($CFG->dirroot.'/mod/scheduler/oneslotform.html');
    print_simple_box_end();
    echo '<br />';

    // return code for include
    return -1;
}
/************************************ Schedule a whole group in form ***********************************************/
if ($action == 'schedulegroup') {
    if($subaction == 'dochooseslot'){
        /// set an advice message
        unset($erroritem);
        $erroritem->message = get_string('dontforgetsaveadvice', 'scheduler');
        $erroritem->on = '';
        $errors[] = $erroritem;

        $slotid = required_param('slotid', PARAM_INT);
        if ($slot = $DB->get_record('scheduler_slots', array('id' => $slotid))){
            $form = &$slot;
            $form->groupid = required_param('groupid', PARAM_INT);
            $form->what = 'doaddupdateslot';
            $form->slotid = $slotid;
            $form->availableslots = scheduler_get_unappointed_slots($scheduler->id);
            $appointments = array();
            $members = groups_get_members($form->groupid);

            // add all group members to the slot, and match exclusivity
            foreach($members as $member){
                unset($appointment);
                // hack for 1.8 / 1.9 compatibility of groups_get_members() call
                if (is_numeric($member)){
                    $appointment->studentid = $member;
                } else {
                    $appointment->studentid = $member->id;
                }
                $appointment->attended = optional_param('attended', 0, PARAM_INT);
                $appointment->grade = optional_param('grade', 0, PARAM_INT);
                $appointment->appointmentnote = optional_param('appointmentnote', '', PARAM_TEXT);
                $appointment->timecreated = time();
                $appointment->timemodified = time();
                $appointments[$appointment->studentid] = $appointment;
            }
            $form->appointments = $appointments;
        } else {
            $form->groupid = $groupid;
            $form->what = 'doaddupdateslot';
            $form->slotid = 0;
            $form->starttime = time();
            $form->duration = 15;
            $form->reuse = 1;
            $form->exclusivity = 1;
            $form->hideuntil = $scheduler->timemodified; // supposed being in the past so slot is visible
            $form->notes = '';
            $form->teacherid = $USER->id;
            $form->appointmentlocation = scheduler_get_last_location($scheduler);
            $form->availableslots = scheduler_get_unappointed_slots($scheduler->id);
            $form->appointments = unserialize(stripslashes(required_param('appointments', PARAM_RAW)));
        }
    } elseif($subaction == 'cancel') {
        get_slot_data($form);
        $form->appointments = unserialize(stripslashes(required_param('appointments', PARAM_RAW)));
        $form->studentid = required_param('studentid', PARAM_INT);
        $form->slotid = required_param('slotid', PARAM_INT);
        $form->availableslots = scheduler_get_unappointed_slots($scheduler->id);
        $form->what = 'doaddupdateslot';
    } elseif(empty($subaction)) {
        if (!empty($errors)){
            get_slot_data($form);
            $form->availableslots = scheduler_get_unappointed_slots($scheduler->id);
            $form->groupid = required_param('groupid', PARAM_INT);
            $form->seen = optional_param('seen', 0, PARAM_INT);
            $form->slotid = optional_param('slotid', -1, PARAM_INT);
        } else {
            $form->groupid = required_param('groupid', PARAM_INT);
            $form->seen = optional_param('seen', 0, PARAM_INT);

            /// getting available slots
            $form->availableslots = scheduler_get_unappointed_slots($scheduler->id);
            $form->what = 'doaddupdateslot' ;
            $form->starttime = time();
            $form->duration = $scheduler->defaultslotduration;
            $form->reuse = 1;
            $form->hideuntil = $scheduler->timemodified; // supposed being in the past so slot is visible
            $form->notes = '';
            $form->teacherid = $USER->id;
            $form->appointmentlocation = scheduler_get_last_location($scheduler);
            $form->slotid = 0;
            $members = groups_get_members($form->groupid);
            $form->exclusivity = count($members);
            foreach($members as $member){
                unset($appointment);
                $appointment->slotid = -1;
                // hack for 1.8 / 1.9 compatibility of groups_get_members() call
                if (is_numeric($member)){
                    $appointment->studentid = $member;
                } else {
                    $appointment->studentid = $member->id;
                }
                $appointment->appointmentnote = '';
                $appointment->attended = $form->seen;
                $appointment->grade = '';
                $appointment->timecreated = time();
                $appointment->timemodified = time();
                $form->appointments[$appointment->studentid] = $appointment;
            }
        }
    } elseif($subaction != '') {
        $retcode = include($CFG->dirroot.'/mod/scheduler/teacherview.subcontroller.php');
        if ($retcode == -1) return -1;
    }

    // display error or advices
    if (!empty($errors)){
        $errorstr = '';
        foreach($errors as $anError){
            $errorstr .= $anError->message;
        }
        print_simple_box($errorstr, 'center', '70%', '', 5, 'errorbox');
    }

    // diplay form
    $form->group = $DB->get_record('groups', array('id' => $form->groupid));
    print_general_tabs($cm, $scheduler, 'unscheduled');
    print_heading(get_string('scheduleappointment', 'scheduler', $form->group->name));
    print_simple_box_start('center', '', '');
    include($CFG->dirroot.'/mod/scheduler/oneslotform.html');
    print_simple_box_end();
    echo '<br />';

    // return code for include
    return -1;
}
//****************** Standard view ***********************************************//


/// print top tabs
    print_general_tabs($cm, $scheduler, $page);

/// print heading
    print_heading($scheduler->name);

/// print page
if ($scheduler->description) {
    print_simple_box(format_text($scheduler->description), 'center');
}

    $timestart = time() + 3600 * $scheduler->reuseguardtime;

if ($page == 'allappointments'){
    $select = "schedulerid = '". $scheduler->id ."'";
} else {
    $select = "schedulerid = '". $scheduler->id ."' AND teacherid = '{$USER->id}'";
    $page = 'myappointments';
}

$sqlcount = $DB->count_records_select('scheduler_slots', $select, NULL);

if (($offset == '') && ($sqlcount > 25)){
    $offsetcount = $DB->count_records_select('scheduler_slots', $select." AND starttime < '".strtotime('now')."'", NULL);
    $offset = floor($offsetcount/25);
}

$slots = $DB->get_records_select('scheduler_slots', $select, NULL, 'starttime', '*', $offset * 25, 25);
if ($slots){
    foreach(array_keys($slots) as $slotid){
        $slots[$slotid]->isappointed = $DB->count_records('scheduler_appointment', array('slotid' => $slotid));
        $slots[$slotid]->isattended = $DB->record_exists('scheduler_appointment', array('slotid' => $slotid, 'attended' => 1));
    }
}

$straddsession = get_string('addsession', 'scheduler');
$straddsingleslot = get_string('addsingleslot', 'scheduler');
$strdownloadexcel = get_string('downloadexcel', 'scheduler');

/// some slots already exist
if ($slots){
    // print instructions and button for creating slots
    print_simple_box_start('center', '', '');
    print_string('addslot', 'scheduler');

    // print add session button
    $strdeleteallslots = get_string('deleteallslots', 'scheduler');
    $strdeleteallunusedslots = get_string('deleteallunusedslots', 'scheduler');
    $strdeleteunusedslots = get_string('deleteunusedslots', 'scheduler');
    $strdeletedateslots = get_string('deletedateslots', 'scheduler');
    $strstudents = $course->students; // get_string('students', 'scheduler');
    $displaydeletebuttons = 1;
    echo '<center>';
    include $CFG->dirroot.'/mod/scheduler/commands.html';
    echo '</center>';
    print_simple_box_end();


    $deleteselected= '<script src="'.$CFG->wwwroot.'/mod/scheduler/scripts/listlib.js"></script>
            <form name="deleteslotsform" style="display : inline">
            <input type="hidden" name="id" value="'.$cm->id.'" />
            <input type="hidden" name="page" value="'.$page.'" />
            <input type="hidden" name="what" value="deleteslots" />
            <input type="hidden" name="items" value="" />
            </form>
            <a href="javascript:document.forms[\'deleteslotsform\'].submit()">'.get_string('deleteselection','scheduler').'</a>';

    // prepare slots table
    if ($page == 'myappointments'){
        $table->head  = array ('', $strdate.'<br />'.$deleteselected, $strstart, $strend, $strlocation, $strstudents, $straction);
        $table->align = array ('CENTER', 'LEFT', 'LEFT', 'LEFT', 'CENTER', 'LEFT', 'CENTER');
        $table->width = '90%';
    } else {
        $table->head  = array ('', $strdate.'<br />'.$deleteselected, $strstart, $strend, $strlocation, $strstudents, format_string($scheduler->staffrolename), $straction);
        $table->align = array ('CENTER', 'LEFT', 'LEFT', 'LEFT', 'CENTER', 'LEFT', 'CENTER', 'CENTER');
        $table->width = '90%';
    }
    $offsetdatemem = '';
    foreach($slots as $slot) {
        if (!$slot->isappointed && $slot->starttime + (60 * $slot->duration) < time()) {
            // This slot is in the past and has not been chosen by any student, so delete
            $DB->delete_records('scheduler_slots', array('id' => $slot->id));
            continue;
        }

        /// Parameter $local in scheduler_userdate and scheduler_usertime added by power-web.at
        /// When local Time or Date is needed the $local Param must be set to 1
        $offsetdate = scheduler_userdate($slot->starttime,1);
        $offsettime = scheduler_usertime($slot->starttime,1);
        $endtime = scheduler_usertime($slot->starttime + ($slot->duration * 60),1);
        $location = format_string($slot->appointmentlocation);

        /// make a slot select box mod/scheduler:deleteall'
        if (($USER->id == $slot->teacherid || has_capability('mod/scheduler:manageallappointments', $context))
                                    && (!$slot->isattended || has_capability('mod/scheduler:deleteall', $context) ) ){
            $selectcheck = "<input type=\"checkbox\" id=\"sel_{$slot->id}\" name=\"sel_{$slot->id}\" onclick=\"document.forms['deleteslotsform'].items.value = toggleListState(document.forms['deleteslotsform'].items.value, 'sel_{$slot->id}', '{$slot->id}');\" />";
        } else {
            $selectcheck = '';
        }

        // slot is appointed
        $studentArray = array();
        if ($slot->isappointed) {
            $appointedstudents = $DB->get_records('scheduler_appointment', array('slotid' => $slot->id));
            if($slot->groupid) { // ULPGC ecastro is a group appointment
                if($group = $DB->get_record('groups', array('id' => $slot->groupid))) {
                    $grouppicture = print_group_picture($group, $course->id, false, true);
                $studentArray[] = '<div style="align: left; ">'.$grouppicture.' '.format_string($group->name).'</div>';
                }
            }
            foreach($appointedstudents as $appstudent){
                $student = $DB->get_record('user', array('id' => $appstudent->studentid));
                $picture = print_user_picture($appstudent->studentid, $course->id, $student->picture, 0, true, true);
                $name = "<a href=\"view.php?what=viewstudent&amp;id={$cm->id}&amp;studentid={$student->id}&amp;course={$scheduler->course}&amp;order=DESC\">".fullname($student).'</a>';


                /// formatting grade
                $grade = $appstudent->grade;
                if ($scheduler->scale > 0 and $grade != ''){
                    $grade = $grade . '/' . $scheduler->scale;
                }
                if ($grade){
                    $grade = "[$grade]";
                }
                $notes = '';
                if($appstudent->appointmentnote) {
                    $notes = '<img name="notes" src="'.$CFG->pixpath.'/t/feedback.gif" border="0" title="'.get_string('studentnotes', 'scheduler').'">';
                }
                if ($USER->id == $slot->teacherid || has_capability('mod/scheduler:manageallappointments', $context)){
                    $checked = ($appstudent->attended) ? 'checked="checked"' : '' ;
                    $checkbox = '<input type="checkbox" name="seen[]" value="'.$appstudent->id.'" '.$checked.' />';
                } else {
                    // same thing but no link
                    if ($appstudent->attended == 1) {
                        $checkbox .= '<img src="pix/ticked.gif" border="0">';
                    } else {
                        $checkbox .= '<img src="pix/unticked.gif" border="0">';
                    }
                }
                $studentArray[] = '<div style="align: left; ">'."$checkbox $picture $grade $notes</div>".
                                            '<div style="align: left; ">'." $name </div>";
            }
        } else {
            // slot is free
            $picture = '';
            $name = '';
            $checkbox = '';
        }

        $actions = '<span style="font-size: x-small;">';
        if ($USER->id == $slot->teacherid || has_capability('mod/scheduler:manageallappointments', $context)){
            //$actions .= "<a href=\"view.php?what=deleteslot&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/t/delete.gif\" alt=\"".get_string('delete')."\" /></a>";
            //$actions .= "&nbsp;<a href=\"view.php?what=updateslot&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/t/edit.gif\" alt=\"".get_string('move', 'scheduler')."\" /></a>";
            if ($slot->isattended){
                $actions .= "&nbsp;<img src=\"pix/ticked.gif\"  title=\"".get_string('isattended', 'scheduler')."\" />";
            } else {
                // ULPGC ecastro moved here because if a slot has been attended, doesn't make sense to move it
                $actions .= "<a href=\"view.php?what=deleteslot&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/t/delete.gif\" title=\"".get_string('delete')."\" /></a>";
                $actions .= "&nbsp;<a href=\"view.php?what=updateslot&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/t/edit.gif\" title=\"".get_string('move', 'scheduler')."\" /></a>";
                if ($slot->isappointed > 1){
                    $actions .= "&nbsp;<img src=\"{$CFG->pixpath}/c/group.gif\" title=\"".get_string('isnoexclusive', 'scheduler')."\" />";
                    // ULPGC ecastro Again, moved here because if attended, makes no sense to revoke afterwards
                    $actions .= "&nbsp;<a href=\"view.php?what=revokeall&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/s/no.gif\" title=\"".get_string('revoke', 'scheduler')."\" /></a>";
                } else {
                    if ($slot->exclusivity == 1){
                        $actions .= "&nbsp;<a href=\"view.php?what=allowgroup&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/t/groupn.gif\" title=\"".get_string('allowgroup', 'scheduler')."\" /></a>";
                    } else {
                        $actions .= "&nbsp;<a href=\"view.php?what=forbidgroup&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/t/groupv.gif\" title=\"".get_string('forbidgroup', 'scheduler')."\" /></a>";
                    }
                }
            }

            /*if ($slot->isappointed){
                $actions .= "&nbsp;<a href=\"view.php?what=revokeall&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"{$CFG->pixpath}/s/no.gif\" alt=\"".get_string('revoke', 'scheduler')."\" /></a>";
            }*/
        } else {
            // just signal group status
            if ($slot->isattended){
                $actions .= "&nbsp;<img src=\"pix/ticked.gif\" title=\"".get_string('isattended', 'scheduler')."\" />";
            } else {
                if ($slot->isappointed > 1){
                    $actions .= "&nbsp;<img src=\"{$CFG->pixpath}/c/group.gif\" title=\"".get_string('isnonexclusive', 'scheduler')."\" />";
                } else {
                    if ($slot->exclusivity == 1){
                        $actions .= "&nbsp;<img src=\"{$CFG->pixpath}/t/groupn.gif\" title=\"".get_string('allowgroup', 'scheduler')."\" />";
                    } else {
                        $actions .= "&nbsp;<img src=\"{$CFG->pixpath}/t/groupv.gif\" title=\"".get_string('forbidgroup', 'scheduler')."\" />";
                    }
                }
            }
        }
        if ($slot->exclusivity > 1){
            $actions .= ' ('.$slot->exclusivity.')';
        }
        if ($slot->reuse){
            $actions .= "&nbsp;<a href=\"view.php?what=unreuse&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"pix/volatile_shadow.gif\" title=\"".get_string('setunreused', 'scheduler')."\" border=\"0\" /></a>";
        } else {
            $actions .= "&nbsp;<a href=\"view.php?what=reuse&amp;id={$cm->id}&amp;slotid={$slot->id}&amp;page={$page}\"><img src=\"pix/volatile.gif\" title=\"".get_string('setreused', 'scheduler')."\" border=\"0\" /></a>";
        }
        $actions .= '</span>';
        if($page == 'myappointments'){
            $table->data[] = array ($selectcheck, ($offsetdate == $offsetdatemem) ? '' : $offsetdate, $offsettime, $endtime, $location, implode("<br />\n",$studentArray), $actions);
        } else {
            $teacherlink = "<a href=\"$CFG->wwwroot/user/view.php?id={$slot->teacherid}\">".fullname($DB->get_record('user', array('id' => $slot->teacherid), 'id, firstname, lastname'))."</a>";
            $table->data[] = array ($selectcheck, ($offsetdate == $offsetdatemem) ? '' : $offsetdate, $offsettime, $endtime, $location, implode("<br />\n",$studentArray), $teacherlink, $actions);
        }
        $offsetdatemem = $offsetdate;
    }

    // print slots table
    print_heading(get_string('slots' ,'scheduler'));

    echo '<div style="width: 80%; margin-left:10%; text-align: center;" >';
    echo get_string('markseen', 'scheduler').'<br />' ;
    if ($sqlcount > 25){

        echo get_string('page').': ';
        $pagescount = ceil($sqlcount/25);
        for ($n = 0; $n < $pagescount; $n ++){
            if ($n == $offset){
                echo ($n+1).' ';
            } else {
                echo "<a href=view.php?id={$cm->id}&amp;page={$page}&amp;offset={$n}>".($n+1)."</a> ";
            }
        }
        echo '<br />';
    }
    echo '</div><br />';

    echo '<form name="appointementsseen" method="post" action="view.php">';

    print_table($table);



    echo '<div style="width: 90%; margin-left:5%; text-align: left;" >';
    echo $deleteselected;
    echo '</div>';

    echo '<div style="width: 90%; margin-left:5%; text-align: center;" >';
    if ($sqlcount > 25){
        echo get_string('page').': ';
        $pagescount = ceil($sqlcount/25);
        for ($n = 0; $n < $pagescount; $n ++){
            if ($n == $offset){
                echo ($n+1).' ';
            } else {
                echo "<a href=view.php?id={$cm->id}&amp;page={$page}&amp;offset={$n}>".($n+1)."</a> ";
            }
        }
        echo '<br />';
    }

    echo '<input type="hidden" name="id" value="'.$cm->id.'" />
            <input type="hidden" name="what" value="saveseen" />
            <input type="hidden" name="page" value="'.$page.'" />
            <input type="hidden" name="offset" value="'.$offset.'" />
            <input type="submit" value="'.get_string('savechanges').'" />
            </form>';

    // Instruction for teacher to click Seen box after appointment
    echo '<br />'. get_string('markseen', 'scheduler');
    echo '</div>';

} else if ($action != 'addsession') {
    /// There are no slots, should the teacher be asked to make some
    print_simple_box_start('center', '', '');
    print_string('welcomenewteacher', 'scheduler');
    echo '<center>';
    $displaydeletebuttons = 0;
    include $CFG->dirroot.'/mod/scheduler/commands.html';
    echo '</center>';
    print_simple_box_end();
}

?>


